#define FUSE_USE_VERSION 27

#include <stdlib.h>
#include <stddef.h>
#include <unistd.h>
#include <fuse.h>
#include <fcntl.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include "estructura_bloques.h"

extern int write_block(int bid, void *buffer);
extern int read_block(int bid, void *buffer);
extern char *get_cwd(void);

char buffer_tmp[SIZE_BLOCK];
struct super_bloque super_b;

int DIRECTORIO_ACTUAL;
int INICIO_MAPABITS;
int TOTALMAPABITS;
int TOTAL_BLOQUES;
int ROOT;

char *getnombre_archivo(const char *path){
    char *nombre = NULL;

    int i;
    for (i = strlen(path) - 2; i >= 0; i--)
    {
        if (path[i] == '/'){
            nombre = path + i + 1;
            break;
        }
    }
    //printf("El valor de nombre es: %s\n",nombre);
    return nombre;
}

char *get_Directorio(const char *path){
    char *nombre = NULL;
    int i;
    for (i = strlen(path) - 2; i >= 0; i--)
    {
        if (path[i] == '/'){
            nombre = (char *) malloc(i + 1);
            memcpy(nombre, path, i + 1);
            break;
        }
    }

    return nombre;
}

int gettotal_niveles(const char *path, int cantidad)
{
    //printf("La cantidad es: %d\n",cantidad);
    if(cantidad==0&&strlen(path)==1)
    {
        return cantidad;
    }
    else
        return cantidad+1;

}

int getniveles(const char *path)
{
    int size=strlen(path);
    int i;
    int cont=0;
    for(i=1;i<size;i++)
    {
        if(path[i]=='/')
        {
            cont++;
        }
    }
    int total=gettotal_niveles(path,cont);
    return total;
}


void conseguirDirectorioRoot()
{
    void * buffer=malloc(SIZE_BLOCK);
    read_block(0,buffer);
    struct super_bloque *sp=buffer;
    DIRECTORIO_ACTUAL=sp->bloque_root;
    INICIO_MAPABITS=sp->primerbloque_mapabits;
    TOTALMAPABITS=sp->sizebloques_mapabits;
    TOTAL_BLOQUES=sp->total_bloques;
    ROOT=sp->bloque_root;
    free(sp);
}

void * endisco_init(struct fuse_conn_info *conn)
{
    read_block(0,&buffer_tmp);
    memcpy(&super_b,buffer_tmp,sizeof(super_b));
    conseguirDirectorioRoot();
    return NULL;
}

int existeDirectorio(const char *path)
{
    void *buffer=calloc(SIZE_BLOCK,1);
    struct directorio *folder=buffer;
    struct entrada_directorio entradas;//=malloc(sizeof(entradas)); 
    read_block(DIRECTORIO_ACTUAL,buffer);
    memcpy(folder,buffer,sizeof(folder));

    int i;
    for(i=0;i<CANT_DIR_ENTRIES;i++)
    {
        entradas=folder->directory_Entries[i];
        if(entradas.tipo_bloque==1)
        {
            if(strcmp(entradas.nombre,path)==0)
                return -1;
        }
    }
    free(folder);
    return 0;
}

int existeArchivo(const char *path)
{
    void *buffer=calloc(SIZE_BLOCK,1);
    struct directorio *folder=buffer;
    struct entrada_directorio entradas;//=malloc(sizeof(entradas));
    read_block(DIRECTORIO_ACTUAL,buffer);
    memcpy(folder,buffer,sizeof(folder));

    int i;
    for(i=0;i<CANT_DIR_ENTRIES;i++)
    {
        entradas=folder->directory_Entries[i];
        if(entradas.tipo_bloque==2)
        {
            if(strcmp(entradas.nombre,path)==0)
                return -1;
        }
    }
    free(folder);
    return 0;
}

int getBloqueLibre()
{
    int i,j,x;

    char buffer[SIZE_BLOCK];
    for(i =INICIO_MAPABITS; i < (INICIO_MAPABITS + TOTALMAPABITS); i++){
        read_block(i,buffer);
        for(j = 0; j < SIZE_BLOCK; j++){
            if (buffer[j] != 0){\
                //printf("byte #%d = %d\n", j + (i * SIZE_BLOCK), (unsigned int)buffer[j]);
                for(x = 0; x < 7; x++){
                    if (buffer[j] & (1 << x)){
                        buffer[j] &= ~(1 << x);
                        write_block(i, buffer);

                        return  (i-INICIO_MAPABITS)*(8+SIZE_BLOCK)+(j*8)+(x);//(i * size_bloques * 8) + (j * 8) + x;
                    }
                }
            }
        }
    }
    return 0; // bloque 0 es utilizado por el super_bloque pro ende es imposible utilizarlo y es considerado cmomo error
    return -1;
}

int hayespacioen_directorio()
{
    void *buffer=calloc(SIZE_BLOCK,1);
    struct directorio *folder=buffer;
    read_block(DIRECTORIO_ACTUAL,buffer);
    memcpy(folder,buffer,sizeof(folder));
    int i;
    int total=(SIZE_BLOCK - 64) / 64;
    for(i=0;i<total;i++)
    {
       // printf("El valor de entradas es de: %d\n",folder->directory_Entries[i].tipo_bloque);
     //   printf("El valor de i es: %d\n",i);
        if(folder->directory_Entries[i].tipo_bloque<=0)
        {
            return i;
        }
    }
    return -1;
}

int setStat(struct stat* sb, struct directorio* entry)
{
    sb->st_dev=0;
    sb->st_ino=0;
    sb->st_rdev=0;
    sb->st_blocks=0;
    sb->st_nlink=1;
    sb->st_uid = entry->uid;
    sb->st_gid = entry->gid;
    sb->st_size = entry->cantidad_elementos;
    sb->st_mtime=entry->fcreacion;
    sb->st_atime = entry->fcreacion;
    sb->st_ctime = entry->fcreacion;
    sb->st_mode = entry->mode |(entry->tipo_bloque ? S_IFDIR : S_IFREG);
    return 0;
}



/*                FUSE           */

static const char *hello_str = "Hello World!\n";
static const char *hello_path = "/hello";

static int endisco_getattr(const char *path, struct stat *sb)
{
    int niveles=getniveles(path);
    DIRECTORIO_ACTUAL=ROOT+niveles;

    int res=0;
    if(DIRECTORIO_ACTUAL>0)
    {
        void *buffer=calloc(SIZE_BLOCK,1);
        struct directorio *folder=buffer;
        read_block(DIRECTORIO_ACTUAL,buffer);
        memcpy(folder,buffer,sizeof(folder));

        setStat(sb,folder);
    }
    else
        res=-ENOENT;
    //printf("CUando llega aqui hay No Hay error\n");
    return res;
    /*
    int res = 0;
    memset(sb, 0, sizeof(struct stat));

    if(strcmp(path, "/") == 0) {
        sb->st_mode = S_IFDIR | 0755;
        sb->st_nlink = 2;
    }
    else if(strcmp(path, hello_path) == 0) {
        sb->st_mode = S_IFREG | 0444;
        sb->st_nlink = 1;
        sb->st_size = strlen(hello_str);
    }
    else
        res = -ENOENT;

    return res;*/
}

static int endisco_readdir(const char *path, void *buf, fuse_fill_dir_t filler,
                            off_t offset, struct fuse_file_info *fi)
{
    int niveles=getniveles(path);
    DIRECTORIO_ACTUAL=ROOT+niveles;
    if(DIRECTORIO_ACTUAL==ROOT)
    {
        struct stat sb;
        char *nombre;

        void *buffer=calloc(SIZE_BLOCK,1);
        struct directorio *folder=buffer;
        read_block(DIRECTORIO_ACTUAL,buffer);
        memcpy(folder,buffer,sizeof(folder));
        int total=(SIZE_BLOCK - 64) / 64;
        int i;
        for(i=0;i<total;i++)
        {
            if(folder->directory_Entries[i].tipo_bloque==1||folder->directory_Entries[i].tipo_bloque==2)
            {
                setStat(&sb,folder);
                nombre=folder->directory_Entries[i].nombre;
                filler(buf,nombre,&sb,0);
            }
        }
    }
    else
    {
        struct stat sb;
        char *nombre;

        void *buffer=calloc(SIZE_BLOCK,1);
        struct directorio *folder=buffer;
        read_block(DIRECTORIO_ACTUAL,buffer);
        memcpy(folder,buffer,sizeof(folder));
        int total=(SIZE_BLOCK - 64) / 64;
        int i;
        for(i=0;i<total;i++)
        {
            if(folder->directory_Entries[i].tipo_bloque==1||folder->directory_Entries[i].tipo_bloque==2)
            {
                setStat(&sb,folder);
                nombre=folder->directory_Entries[i].nombre;
                filler(buf,nombre,&sb,0);
            }
        }
    }


    return 0;

}

static int endisco_create(const char *path, mode_t mode,
             struct fuse_file_info *fi)
{


    int id_nombre=existeArchivo(path);
    char path_archivo=getnombre_archivo(path);

    if(id_nombre==-1)
        return -EEXIST;

    else
    {
        int disponible=hayespacioen_directorio();
        if(disponible==-1)
            return -EACCES;

        else
        {
            int bloque_disponible=getBloqueLibre();
            if(bloque_disponible==-1)
                return -EACCES;

            else
            {
                void *buffer=malloc(SIZE_BLOCK);
                struct directorio *folder=buffer;
                read_block(DIRECTORIO_ACTUAL,buffer);
                memcpy(folder,buffer,sizeof(folder));
                folder->directory_Entries[disponible].apuntador=bloque_disponible;
                memcpy(folder->directory_Entries[disponible].nombre,path_archivo,58);
                folder->directory_Entries[disponible].tipo_bloque=2;
                memcpy(buffer,folder,sizeof(SIZE_BLOCK));
                write_block(DIRECTORIO_ACTUAL,buffer);

                void *tmp=malloc(SIZE_BLOCK);
                struct file_control *archivo=tmp;
                archivo->uid=getuid();
                archivo->gid=getgid();
                archivo->mode=mode;
                archivo->tipo_bloque=2;
                memcpy(archivo->creador,path_archivo,44);
                write_block(bloque_disponible,tmp);
                //memcpy(folder->directory_Entries[espacio_directorio].nombre,path2,58);
            }

        }
    }
}

static int endisco_mkdir(const char *path, mode_t mode)
{
    char *pwd;
    pwd=get_cwd();
    int niveles=getniveles(pwd);
    DIRECTORIO_ACTUAL=ROOT+niveles;
    char *path2=getnombre_archivo(path);
    int id_nombre=existeDirectorio(path2);


    if(id_nombre==-1)
    {
        return -EEXIST;
    }else
    {
     //   printf("Entra aqui\n");
        int espacio_directorio=hayespacioen_directorio();
      //  printf("\n El espacio en directorio es igual a: %d\n",espacio_directorio);
        if(espacio_directorio==-1){
            return -EACCES;
        }else
        {
            int bloque_disponible=getBloqueLibre();
            if(bloque_disponible==-1)
            {;
                return  -EACCES;
            }else
            {
                void *buffer=malloc(SIZE_BLOCK);
                struct directorio *folder=buffer;
                read_block(DIRECTORIO_ACTUAL,buffer);
                memcpy(folder,buffer,sizeof(folder));
                folder->directory_Entries[espacio_directorio].apuntador=bloque_disponible;
                memcpy(folder->directory_Entries[espacio_directorio].nombre,path2,58);
                folder->directory_Entries[espacio_directorio].tipo_bloque=1;
                memcpy(buffer,folder,sizeof(SIZE_BLOCK));
                write_block(DIRECTORIO_ACTUAL,buffer);

                void *tmp=malloc(SIZE_BLOCK);
                struct directorio *actual_dir=tmp;
                actual_dir->mode=mode;
                actual_dir->tipo_bloque=1;
                memcpy(actual_dir->creador,"Diego Turcios Lara", 44);
                actual_dir->fcreacion=10;
                actual_dir->gid=getgid();
                actual_dir->uid=getuid();
                actual_dir->cantidad_elementos=CANT_DIR_ENTRIES;
                actual_dir->fmodificacion=10;
             //   printf("LLego aqui version 5\n");
                write_block(bloque_disponible,tmp);
                printf("Se creo exitosamente la carpeta\n");


            }
        }
    }

    return 0;
}

static int endisco_unlink(const char *path)
{
    return -EOPNOTSUPP;
}

static int endisco_rmdir(const char *path)
{
    return -EOPNOTSUPP;
}

static int endisco_rename(const char *src_path, const char *dst_path)
{
    char *pwd;
    pwd=get_cwd();
    int niveles=getniveles(pwd);
    DIRECTORIO_ACTUAL=ROOT+niveles;
    char *verdadero_nombre=getnombre_archivo(src_path);
    char *nuevo_nombre=getnombre_archivo(dst_path);
    int id_folder=existeDirectorio(verdadero_nombre);
    if(id_folder!=-1)
    {
        return -ENOENT;
    }
    else
    {
        void *buffer=malloc(SIZE_BLOCK);
        struct directorio *folder=buffer;
        read_block(DIRECTORIO_ACTUAL,buffer);
        memcpy(folder,buffer,sizeof(folder));
        int i;
        for(i=0;i<CANT_DIR_ENTRIES;i++)
        {
            if(strcmp(folder->directory_Entries[i].nombre,verdadero_nombre)==0)
            {
                memcpy(folder->directory_Entries[i].nombre,nuevo_nombre,44);
                write_block(DIRECTORIO_ACTUAL,buffer);
                return 0;
            }
        }

    }
    return -ENOTDIR;
}

static int endisco_chmod(const char *path, mode_t mode)
{
    return -EOPNOTSUPP;
}
int endisco_utime(const char *path, struct utimbuf *ut)
{
    return -EOPNOTSUPP;
}

static int endisco_truncate(const char *path, off_t len)
{
    /* you can cheat by only implementing this for the case of len==0,
     * and an error otherwise.
     */
    if (len != 0)
    return -EINVAL;		/* invalid argument */

    return -EOPNOTSUPP;
}

static int endisco_write(const char *path, const char *buf, size_t len,
             off_t offset, struct fuse_file_info *fi)
{
    return -EOPNOTSUPP;
}

static int endisco_statfs(const char *path, struct statvfs *st)
{
    /* needs to return the following fields (set others to zero):
     *   f_bsize = BLOCK_SIZE
     *   f_blocks = total image - (superblock + FAT)
     *   f_bfree = f_blocks - blocks used
     *   f_bavail = f_bfree
     *   f_namelen = <whatever your max namelength is>
     *
     * it's OK to calculate this dynamically on the rare occasions
     * when this function is called.
     */
    return -EOPNOTSUPP;
}

static int endisco_read(const char *path, char *buf, size_t len, off_t offset,
            struct fuse_file_info *fi)
{
    return -EOPNOTSUPP;
}


struct fuse_operations turcios_FS =
{
    .init = endisco_init,
    .getattr = endisco_getattr,
    .readdir = endisco_readdir,
    .create = endisco_create,
    .mkdir = endisco_mkdir,
    .unlink = endisco_unlink,
    .rmdir = endisco_rmdir,
    .rename = endisco_rename,
    .chmod = endisco_chmod,
    .utime = endisco_utime,
    .truncate = endisco_truncate,
    .read = endisco_read,
    .write = endisco_write,
    .statfs = endisco_statfs,
};

int need_img = 1;
