#define _XOPEN_SOURCE 500  //ESTO ES NECESARIO PARA EL PWRITE Y PREAD
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <ctype.h>

#include "estructura_bloques.h"

int escribir_bloque(int fd, int lba, void *buffer)
{
    return pwrite(fd, buffer, SIZE_BLOCK, lba*SIZE_BLOCK); //funcion para escribir son para linux
}

int leer_bloque(int fd, int lba, void *buffer)
{
    return pread(fd, buffer, SIZE_BLOCK, lba*SIZE_BLOCK);// funcion para leer son para linux
}

#include <getopt.h> /*Este include es para parsiar argumentos de la consola */

unsigned long parsiarint(char *s)
{
    unsigned long valor= strtol(s,&s,0); /*convierte la parte inicial de la cadena nptr en un valor entero largo de acuerdo con la base dada */
    if(toupper(*s)== 'G')
        valor*=(1024*1024*1024);
    if(toupper(*s)=='M')
        valor*=(1024*1024*1024);
    if(toupper(*s)=='K')
        valor*=(1024);

    return valor;
}

void mensaje()
{
    printf("uso: mkfs-turcios [--crear <tamano (g|m|k)>] <image-file>\n");
    exit(1);
}

int main(int argc, char **argv)
{
    char *path;
    int i;
    int c;
    int fd, numero_bloques;
    struct stat sb;
    unsigned long size_disco=0;
    void *buffer=calloc(SIZE_BLOCK,1);

    static struct option opciones[]={
                                      {"crear",required_argument, NULL, 'c'},
                                      {0,0,0,0}
                                    };/*El Struct getgetopt.h*/

    while((c=getopt_long_only(argc, argv, "", opciones, NULL)) !=-1)

    switch(c)
    {
        case 'c': size_disco=parsiarint(optarg);
            break;
        default: printf("Erro opcion erronea");
    }

    if(optind >=argc)
    {
        mensaje();
    }
    path=argv[optind];

    /* Ver que tan grande es la imagen o crear una nueva */
    if(size_disco==0)
    {
        if((fd=open(path,O_WRONLY,0777)<0 ||fstat(fd,&sb)< 0))/* O_WRONLY viene de fcntl.h  y el fstat() de stat.h*/
        {
            perror("Error al abrir el archivo\n"),
            exit(1);
        }
        numero_bloques=sb.st_size/SIZE_BLOCK;  /* Size of file, in bytes.*/
    }

    else
    {
        numero_bloques=size_disco/SIZE_BLOCK;
        if((fd=open(path,O_WRONLY|O_CREAT|O_TRUNC))<0)
        {
              perror("Error al crear el archivo"),exit(1);
        }
        for(i=0;i<numero_bloques;i++)
        {
              if(write(fd,buffer,SIZE_BLOCK)<0)
              {
                    perror("Error al escribir al archivo"),exit(1);
               }
        }
               lseek(fd,0,SEEK_SET);
     }

     /* Escribir superbloque */

    struct super_bloque *sp=buffer;
    sp->magic_number=MAGIC;
    sp->size_bloques=SIZE_BLOCK;
    sp->total_bloques=numero_bloques;
    sp->bloque_root=3;
    sp->bloques_libres=numero_bloques-5;
    sp->primerbloque_mapabits=3;
    sp->sizebloques_mapabits=2;

    escribir_bloque(fd,0,buffer);


    /* Aqui tiene que ir el mapa de bits */


    const int cantidad_estructdirectorios=SIZE_BLOCK/sizeof(struct directorio);
    struct directorio *folder=buffer;

    for(i=0;i<cantidad_estructdirectorios;i++)
        folder[i].valid=0;

    escribir_bloque(fd,1+2,buffer);

    close(fd);

    return 0;



}


